=== debian/changelog ===
libheif (1.17.6-3build2) oracular; urgency=medium

  * Rebuild against new libsvtav1enc2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 10 Jul 2024 16:41:20 +0200

libheif (1.17.6-3build1) oracular; urgency=medium

  * Rebuild against new libx265-209.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 11 Jun 2024 10:43:32 +0200

libheif (1.17.6-3) unstable; urgency=medium

  * Team upload
  * Stop building rav1e plugin on i386
  * On Ubuntu, demote libheif-plugin-x265 to Suggests
    and prefer libheif-plugin-aomdec to libheif-plugin-dav1d (LP: #2061089)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 06 Jun 2024 10:10:36 -0400

libheif (1.17.6-2) unstable; urgency=medium

  [ Dylan Aïssi ]
  * Cherry-pick upstream patches:
      - a911b26: Fix compilation with libsvtav1 2.0.0 (Closes: #1072335)
      - 877de6b: fix memory leaks (CVE-2024-25269)

  [ Joachim Bauch ]
  * d/control: Update "Standards-Version" to 4.7.0
  * Migrate from "pkg-config" to "pkgconf".

 -- Joachim Bauch <bauch@struktur.de>  Mon, 03 Jun 2024 13:28:11 +0200

libheif (1.17.6-1) unstable; urgency=medium

  * New upstream version 1.17.6
  * Fixes CVE-2023-49460, CVE-2023-49462, CVE-2023-49463,
    CVE-2023-49464 (Closes: #1059151).
  * Remove patch now applied upstream.

 -- Joachim Bauch <bauch@struktur.de>  Thu, 21 Dec 2023 10:45:41 +0100

libheif (1.17.4-1) unstable; urgency=medium

  * New upstream version 1.17.4
  * Add patch to fix installing thumbnailer file.

 -- Joachim Bauch <bauch@struktur.de>  Tue, 21 Nov 2023 10:03:52 +0100

libheif (1.17.1-1) unstable; urgency=medium

  * New upstream version 1.17.1

 -- Joachim Bauch <bauch@struktur.de>  Mon, 23 Oct 2023 11:04:57 +0200

libheif (1.17.0-1) unstable; urgency=medium

  * New upstream version 1.17.0
    - Fix loading of plugins in some cases (Closes: #1041242, #1043506)
  * Update symbols for new upstream version.
  * Update codec selection for new upstream version.
  * Build new codec plugins (ffmpegdec, jpeg{dec,enc}, j2k{dec,enc}).
  * Pass path to plugins when running tests.

 -- Joachim Bauch <bauch@struktur.de>  Mon, 16 Oct 2023 14:30:23 +0200

libheif (1.16.2-3) unstable; urgency=medium

  * Team upload
  * Explicitly enable sharpyuv and have libheif-dev depend on libsharpyuv-dev
    per its pkgconfig file. Previously this was an automagic dependency
    and the pkgconfig file broke with a binNMU (Closes: #1052932)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 30 Sep 2023 05:23:55 -0400
